<?php

namespace Teknisa\FIN\Modules\MovimentacaoBancaria\Services;

use Teknisa\FIN\Modules\MovimentacaoBancaria\Factories\Bco21200RelacaoSaldosContaCorrenteFactory;
use Teknisa\Libs\Util\Masks\Masks;

class Bco21200RelacaoSaldosContaCorrenteService { 
  
  protected $factory;
  protected $masks;
  
  public function __construct(Masks $masks, Bco21200RelacaoSaldosContaCorrenteFactory $factory) {
    $this->masks = $masks;
    $this->factory = $factory;
  }
  
  public function setSaldos($relacoesArray) {
    
    /*$codigos = "";
    
    foreach($relacoesArray as $row) {
      var_dump($row['SALDO'] + $row['VRLIMITCREDCCOR']);die;
      $arraySaldos = $this->factory->findSaldos($row['CDREDUCONT'], $relacoesArray[0]['DATA']);
      
      //$row['SALDO'] = isset($arraySaldos[$row['CDREDUCONT']]) ? $arraySaldos[$row['SALDO']] : 0;
      $row['SALDOCLIM'] = $row['SALDO'] + $row['VRLIMITCREDCCOR'];
      $row['DEBCRED'] = $row['SALDOCLIM'] >= 0 ? 'CR' : 'DB';
    };
    $arraySaldos = $this->factory->findSaldos($codigos, $relacoesArray[0]['DATA']);
    foreach($relacoesArray as $index => $row) {
      $relacoesArray[$index]['SALDO'] = isset($arraySaldos[$row['CDREDUCONT']]) ? $arraySaldos[$row['SALDO']] : 0;
      $relacoesArray[$index]['SALDOCLIM'] = $relacoesArray[$index]['SALDO'] + $relacoesArray[$index]['VRLIMITCREDCCOR'];
      $relacoesArray[$index]['DEBCRED'] = $relacoesArray[$index]['SALDOCLIM'] >= 0 ? 'CR' : 'DB';
      
    }*/
    
    return $relacoesArray;
    
  }
  
  public function setMascaras(&$rows) {
    for($i = 0; count($rows) > $i; $i++){
      //Retira pontos (.) e traços (-) da mascará para comparação de caracteres
      $matches = array();
      preg_match_all('/[^-.]*/',$rows[$i]['CDPICTAGEN'], $matches);
      $unmaskedString = implode('', $matches[0]);
      if(strlen($rows[$i]['CDAGENCIA']) === strlen($unmaskedString)) {
          $rows[$i]['CDAGENCIAMASK'] = $this->masks->mask($rows[$i]['CDAGENCIA'], $rows[$i]['CDPICTAGEN']);
      } else {
          $rows[$i]['CDAGENCIAMASK'] = $rows[$i]['CDAGENCIA'];
      }
      
      //Retira pontos (.) e traços (-) da mascará para comparação de caracteres
      $matches = array();
      preg_match_all('/[^-.]*/',$rows[$i]['CDPICTCONT'], $matches);
      $unmaskedString = implode('', $matches[0]);
      if (strlen($rows[$i]['CDCONTCORR']) === strlen($unmaskedString)) {
          $rows[$i]['CDCONTCORRMASK'] = $this->masks->mask($rows[$i]['CDCONTCORR'], $rows[$i]['CDPICTCONT']);
      } else {
          $rows[$i]['CDCONTCORRMASK'] = $rows[$i]['CDCONTCORR'];
      }
      
    }
    
    
  }
  
}